# coding: utf-8

"""
    Gradient AI API

    Interface for interacting with Gradient AI.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: support@gradient.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist, constr, validator
from gradientai.openapi.client.models.create_rag_collection_body_params_files_inner import CreateRagCollectionBodyParamsFilesInner

class CreateRagCollectionBodyParams(BaseModel):
    """
    CreateRagCollectionBodyParams
    """
    files: Optional[conlist(CreateRagCollectionBodyParamsFilesInner, max_items=20)] = None
    name: constr(strict=True, min_length=1) = Field(...)
    slug: StrictStr = Field(...)
    additional_properties: Dict[str, Any] = {}
    __properties = ["files", "name", "slug"]

    @validator('slug')
    def slug_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('bge-large'):
            raise ValueError("must be one of enum values ('bge-large')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateRagCollectionBodyParams:
        """Create an instance of CreateRagCollectionBodyParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "additional_properties"
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in files (list)
        _items = []
        if self.files:
            for _item in self.files:
                if _item:
                    _items.append(_item.to_dict())
            _dict['files'] = _items
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        # set to None if files (nullable) is None
        # and __fields_set__ contains the field
        if self.files is None and "files" in self.__fields_set__:
            _dict['files'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateRagCollectionBodyParams:
        """Create an instance of CreateRagCollectionBodyParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateRagCollectionBodyParams.parse_obj(obj)

        _obj = CreateRagCollectionBodyParams.parse_obj({
            "files": [CreateRagCollectionBodyParamsFilesInner.from_dict(_item) for _item in obj.get("files")] if obj.get("files") is not None else None,
            "name": obj.get("name"),
            "slug": obj.get("slug")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj

